<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RUniversalLineTemplate StructType
 * @subpackage Structs
 */
class RUniversalLineTemplate extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The urgentPriority
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $urgentPriority;
    /**
     * The lineDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $lineDescription;
    /**
     * The routePartition
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $routePartition;
    /**
     * The voiceMailProfile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $voiceMailProfile;
    /**
     * The callingSearchSpace
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $callingSearchSpace;
    /**
     * The alertingName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $alertingName;
    /**
     * The extCallControlProfile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $extCallControlProfile;
    /**
     * The blfPresenceGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $blfPresenceGroup;
    /**
     * The callPickupGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $callPickupGroup;
    /**
     * The partyEntranceTone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $partyEntranceTone;
    /**
     * The autoAnswer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $autoAnswer;
    /**
     * The rejectAnonymousCall
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $rejectAnonymousCall;
    /**
     * The userHoldMohAudioSource
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $userHoldMohAudioSource;
    /**
     * The networkHoldMohAudioSource
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $networkHoldMohAudioSource;
    /**
     * The aarDestinationMask
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - maxLength: 128
     * @var string
     */
    public $aarDestinationMask;
    /**
     * The aarGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $aarGroup;
    /**
     * The retainDestInCallFwdHistory
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $retainDestInCallFwdHistory;
    /**
     * The forwardDestAllCalls
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $forwardDestAllCalls;
    /**
     * The primaryCssForwardingAllCalls
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $primaryCssForwardingAllCalls;
    /**
     * The secondaryCssForwardingAllCalls
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $secondaryCssForwardingAllCalls;
    /**
     * The CssActivationPolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CssActivationPolicy;
    /**
     * The fwdDestExtCallsWhenNotRetrieved
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fwdDestExtCallsWhenNotRetrieved;
    /**
     * The cssFwdExtCallsWhenNotRetrieved
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $cssFwdExtCallsWhenNotRetrieved;
    /**
     * The fwdDestInternalCallsWhenNotRetrieved
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $fwdDestInternalCallsWhenNotRetrieved;
    /**
     * The cssFwdInternalCallsWhenNotRetrieved
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $cssFwdInternalCallsWhenNotRetrieved;
    /**
     * The parkMonitorReversionTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $parkMonitorReversionTime;
    /**
     * The target
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $target;
    /**
     * The mlppCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $mlppCss;
    /**
     * The mlppNoAnsRingDuration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mlppNoAnsRingDuration;
    /**
     * The confidentialAccess
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var ConfidentialAccess
     */
    public $confidentialAccess;
    /**
     * The holdReversionRingDuration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $holdReversionRingDuration;
    /**
     * The holdReversionNotificationInterval
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $holdReversionNotificationInterval;
    /**
     * The busyIntCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $busyIntCallsDestination;
    /**
     * The busyIntCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $busyIntCallsCss;
    /**
     * The busyExtCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $busyExtCallsDestination;
    /**
     * The busyExtCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $busyExtCallsCss;
    /**
     * The noAnsIntCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $noAnsIntCallsDestination;
    /**
     * The noAnsIntCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $noAnsIntCallsCss;
    /**
     * The noAnsExtCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $noAnsExtCallsDestination;
    /**
     * The noAnsExtCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $noAnsExtCallsCss;
    /**
     * The noCoverageIntCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $noCoverageIntCallsDestination;
    /**
     * The noCoverageIntCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $noCoverageIntCallsCss;
    /**
     * The noCoverageExtCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $noCoverageExtCallsDestination;
    /**
     * The noCoverageExtCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $noCoverageExtCallsCss;
    /**
     * The unregisteredIntCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $unregisteredIntCallsDestination;
    /**
     * The unregisteredIntCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $unregisteredIntCallsCss;
    /**
     * The unregisteredExtCallsDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $unregisteredExtCallsDestination;
    /**
     * The unregisteredExtCallsCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $unregisteredExtCallsCss;
    /**
     * The ctiFailureDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $ctiFailureDestination;
    /**
     * The ctiFailureCss
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var XFkType
     */
    public $ctiFailureCss;
    /**
     * The callControlAgentProfile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $callControlAgentProfile;
    /**
     * The enterpriseAltNum
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var EnterpriseAltNum
     */
    public $enterpriseAltNum;
    /**
     * The e164AltNum
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var E164AltNum
     */
    public $e164AltNum;
    /**
     * The advertisedFailoverNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $advertisedFailoverNumber;
    /**
     * The uuid
     * Meta informations extracted from the WSDL
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RUniversalLineTemplate
     * @uses RUniversalLineTemplate::setName()
     * @uses RUniversalLineTemplate::setUrgentPriority()
     * @uses RUniversalLineTemplate::setLineDescription()
     * @uses RUniversalLineTemplate::setRoutePartition()
     * @uses RUniversalLineTemplate::setVoiceMailProfile()
     * @uses RUniversalLineTemplate::setCallingSearchSpace()
     * @uses RUniversalLineTemplate::setAlertingName()
     * @uses RUniversalLineTemplate::setExtCallControlProfile()
     * @uses RUniversalLineTemplate::setBlfPresenceGroup()
     * @uses RUniversalLineTemplate::setCallPickupGroup()
     * @uses RUniversalLineTemplate::setPartyEntranceTone()
     * @uses RUniversalLineTemplate::setAutoAnswer()
     * @uses RUniversalLineTemplate::setRejectAnonymousCall()
     * @uses RUniversalLineTemplate::setUserHoldMohAudioSource()
     * @uses RUniversalLineTemplate::setNetworkHoldMohAudioSource()
     * @uses RUniversalLineTemplate::setAarDestinationMask()
     * @uses RUniversalLineTemplate::setAarGroup()
     * @uses RUniversalLineTemplate::setRetainDestInCallFwdHistory()
     * @uses RUniversalLineTemplate::setForwardDestAllCalls()
     * @uses RUniversalLineTemplate::setPrimaryCssForwardingAllCalls()
     * @uses RUniversalLineTemplate::setSecondaryCssForwardingAllCalls()
     * @uses RUniversalLineTemplate::setCssActivationPolicy()
     * @uses RUniversalLineTemplate::setFwdDestExtCallsWhenNotRetrieved()
     * @uses RUniversalLineTemplate::setCssFwdExtCallsWhenNotRetrieved()
     * @uses RUniversalLineTemplate::setFwdDestInternalCallsWhenNotRetrieved()
     * @uses RUniversalLineTemplate::setCssFwdInternalCallsWhenNotRetrieved()
     * @uses RUniversalLineTemplate::setParkMonitorReversionTime()
     * @uses RUniversalLineTemplate::setTarget()
     * @uses RUniversalLineTemplate::setMlppCss()
     * @uses RUniversalLineTemplate::setMlppNoAnsRingDuration()
     * @uses RUniversalLineTemplate::setConfidentialAccess()
     * @uses RUniversalLineTemplate::setHoldReversionRingDuration()
     * @uses RUniversalLineTemplate::setHoldReversionNotificationInterval()
     * @uses RUniversalLineTemplate::setBusyIntCallsDestination()
     * @uses RUniversalLineTemplate::setBusyIntCallsCss()
     * @uses RUniversalLineTemplate::setBusyExtCallsDestination()
     * @uses RUniversalLineTemplate::setBusyExtCallsCss()
     * @uses RUniversalLineTemplate::setNoAnsIntCallsDestination()
     * @uses RUniversalLineTemplate::setNoAnsIntCallsCss()
     * @uses RUniversalLineTemplate::setNoAnsExtCallsDestination()
     * @uses RUniversalLineTemplate::setNoAnsExtCallsCss()
     * @uses RUniversalLineTemplate::setNoCoverageIntCallsDestination()
     * @uses RUniversalLineTemplate::setNoCoverageIntCallsCss()
     * @uses RUniversalLineTemplate::setNoCoverageExtCallsDestination()
     * @uses RUniversalLineTemplate::setNoCoverageExtCallsCss()
     * @uses RUniversalLineTemplate::setUnregisteredIntCallsDestination()
     * @uses RUniversalLineTemplate::setUnregisteredIntCallsCss()
     * @uses RUniversalLineTemplate::setUnregisteredExtCallsDestination()
     * @uses RUniversalLineTemplate::setUnregisteredExtCallsCss()
     * @uses RUniversalLineTemplate::setCtiFailureDestination()
     * @uses RUniversalLineTemplate::setCtiFailureCss()
     * @uses RUniversalLineTemplate::setCallControlAgentProfile()
     * @uses RUniversalLineTemplate::setEnterpriseAltNum()
     * @uses RUniversalLineTemplate::setE164AltNum()
     * @uses RUniversalLineTemplate::setAdvertisedFailoverNumber()
     * @uses RUniversalLineTemplate::setUuid()
     * @param string $name
     * @param string $urgentPriority
     * @param string $lineDescription
     * @param XFkType $routePartition
     * @param XFkType $voiceMailProfile
     * @param XFkType $callingSearchSpace
     * @param string $alertingName
     * @param XFkType $extCallControlProfile
     * @param XFkType $blfPresenceGroup
     * @param XFkType $callPickupGroup
     * @param string $partyEntranceTone
     * @param string $autoAnswer
     * @param string $rejectAnonymousCall
     * @param string $userHoldMohAudioSource
     * @param string $networkHoldMohAudioSource
     * @param string $aarDestinationMask
     * @param XFkType $aarGroup
     * @param string $retainDestInCallFwdHistory
     * @param string $forwardDestAllCalls
     * @param XFkType $primaryCssForwardingAllCalls
     * @param XFkType $secondaryCssForwardingAllCalls
     * @param string $cssActivationPolicy
     * @param string $fwdDestExtCallsWhenNotRetrieved
     * @param XFkType $cssFwdExtCallsWhenNotRetrieved
     * @param string $fwdDestInternalCallsWhenNotRetrieved
     * @param XFkType $cssFwdInternalCallsWhenNotRetrieved
     * @param string $parkMonitorReversionTime
     * @param string $target
     * @param XFkType $mlppCss
     * @param string $mlppNoAnsRingDuration
     * @param ConfidentialAccess $confidentialAccess
     * @param string $holdReversionRingDuration
     * @param string $holdReversionNotificationInterval
     * @param string $busyIntCallsDestination
     * @param XFkType $busyIntCallsCss
     * @param string $busyExtCallsDestination
     * @param XFkType $busyExtCallsCss
     * @param string $noAnsIntCallsDestination
     * @param XFkType $noAnsIntCallsCss
     * @param string $noAnsExtCallsDestination
     * @param XFkType $noAnsExtCallsCss
     * @param string $noCoverageIntCallsDestination
     * @param XFkType $noCoverageIntCallsCss
     * @param string $noCoverageExtCallsDestination
     * @param XFkType $noCoverageExtCallsCss
     * @param string $unregisteredIntCallsDestination
     * @param XFkType $unregisteredIntCallsCss
     * @param string $unregisteredExtCallsDestination
     * @param XFkType $unregisteredExtCallsCss
     * @param string $ctiFailureDestination
     * @param XFkType $ctiFailureCss
     * @param string $callControlAgentProfile
     * @param EnterpriseAltNum $enterpriseAltNum
     * @param E164AltNum $e164AltNum
     * @param string $advertisedFailoverNumber
     * @param string $uuid
     */
    public function __construct($name = null, $urgentPriority = null, $lineDescription = null, XFkType $routePartition = null, XFkType $voiceMailProfile = null, XFkType $callingSearchSpace = null, $alertingName = null, XFkType $extCallControlProfile = null, XFkType $blfPresenceGroup = null, XFkType $callPickupGroup = null, $partyEntranceTone = null, $autoAnswer = null, $rejectAnonymousCall = null, $userHoldMohAudioSource = null, $networkHoldMohAudioSource = null, $aarDestinationMask = null, XFkType $aarGroup = null, $retainDestInCallFwdHistory = null, $forwardDestAllCalls = null, XFkType $primaryCssForwardingAllCalls = null, XFkType $secondaryCssForwardingAllCalls = null, $cssActivationPolicy = null, $fwdDestExtCallsWhenNotRetrieved = null, XFkType $cssFwdExtCallsWhenNotRetrieved = null, $fwdDestInternalCallsWhenNotRetrieved = null, XFkType $cssFwdInternalCallsWhenNotRetrieved = null, $parkMonitorReversionTime = null, $target = null, XFkType $mlppCss = null, $mlppNoAnsRingDuration = null, ConfidentialAccess $confidentialAccess = null, $holdReversionRingDuration = null, $holdReversionNotificationInterval = null, $busyIntCallsDestination = null, XFkType $busyIntCallsCss = null, $busyExtCallsDestination = null, XFkType $busyExtCallsCss = null, $noAnsIntCallsDestination = null, XFkType $noAnsIntCallsCss = null, $noAnsExtCallsDestination = null, XFkType $noAnsExtCallsCss = null, $noCoverageIntCallsDestination = null, XFkType $noCoverageIntCallsCss = null, $noCoverageExtCallsDestination = null, XFkType $noCoverageExtCallsCss = null, $unregisteredIntCallsDestination = null, XFkType $unregisteredIntCallsCss = null, $unregisteredExtCallsDestination = null, XFkType $unregisteredExtCallsCss = null, $ctiFailureDestination = null, XFkType $ctiFailureCss = null, $callControlAgentProfile = null, EnterpriseAltNum $enterpriseAltNum = null, E164AltNum $e164AltNum = null, $advertisedFailoverNumber = null, $uuid = null)
    {
        $this
            ->setName($name)
            ->setUrgentPriority($urgentPriority)
            ->setLineDescription($lineDescription)
            ->setRoutePartition($routePartition)
            ->setVoiceMailProfile($voiceMailProfile)
            ->setCallingSearchSpace($callingSearchSpace)
            ->setAlertingName($alertingName)
            ->setExtCallControlProfile($extCallControlProfile)
            ->setBlfPresenceGroup($blfPresenceGroup)
            ->setCallPickupGroup($callPickupGroup)
            ->setPartyEntranceTone($partyEntranceTone)
            ->setAutoAnswer($autoAnswer)
            ->setRejectAnonymousCall($rejectAnonymousCall)
            ->setUserHoldMohAudioSource($userHoldMohAudioSource)
            ->setNetworkHoldMohAudioSource($networkHoldMohAudioSource)
            ->setAarDestinationMask($aarDestinationMask)
            ->setAarGroup($aarGroup)
            ->setRetainDestInCallFwdHistory($retainDestInCallFwdHistory)
            ->setForwardDestAllCalls($forwardDestAllCalls)
            ->setPrimaryCssForwardingAllCalls($primaryCssForwardingAllCalls)
            ->setSecondaryCssForwardingAllCalls($secondaryCssForwardingAllCalls)
            ->setCssActivationPolicy($cssActivationPolicy)
            ->setFwdDestExtCallsWhenNotRetrieved($fwdDestExtCallsWhenNotRetrieved)
            ->setCssFwdExtCallsWhenNotRetrieved($cssFwdExtCallsWhenNotRetrieved)
            ->setFwdDestInternalCallsWhenNotRetrieved($fwdDestInternalCallsWhenNotRetrieved)
            ->setCssFwdInternalCallsWhenNotRetrieved($cssFwdInternalCallsWhenNotRetrieved)
            ->setParkMonitorReversionTime($parkMonitorReversionTime)
            ->setTarget($target)
            ->setMlppCss($mlppCss)
            ->setMlppNoAnsRingDuration($mlppNoAnsRingDuration)
            ->setConfidentialAccess($confidentialAccess)
            ->setHoldReversionRingDuration($holdReversionRingDuration)
            ->setHoldReversionNotificationInterval($holdReversionNotificationInterval)
            ->setBusyIntCallsDestination($busyIntCallsDestination)
            ->setBusyIntCallsCss($busyIntCallsCss)
            ->setBusyExtCallsDestination($busyExtCallsDestination)
            ->setBusyExtCallsCss($busyExtCallsCss)
            ->setNoAnsIntCallsDestination($noAnsIntCallsDestination)
            ->setNoAnsIntCallsCss($noAnsIntCallsCss)
            ->setNoAnsExtCallsDestination($noAnsExtCallsDestination)
            ->setNoAnsExtCallsCss($noAnsExtCallsCss)
            ->setNoCoverageIntCallsDestination($noCoverageIntCallsDestination)
            ->setNoCoverageIntCallsCss($noCoverageIntCallsCss)
            ->setNoCoverageExtCallsDestination($noCoverageExtCallsDestination)
            ->setNoCoverageExtCallsCss($noCoverageExtCallsCss)
            ->setUnregisteredIntCallsDestination($unregisteredIntCallsDestination)
            ->setUnregisteredIntCallsCss($unregisteredIntCallsCss)
            ->setUnregisteredExtCallsDestination($unregisteredExtCallsDestination)
            ->setUnregisteredExtCallsCss($unregisteredExtCallsCss)
            ->setCtiFailureDestination($ctiFailureDestination)
            ->setCtiFailureCss($ctiFailureCss)
            ->setCallControlAgentProfile($callControlAgentProfile)
            ->setEnterpriseAltNum($enterpriseAltNum)
            ->setE164AltNum($e164AltNum)
            ->setAdvertisedFailoverNumber($advertisedFailoverNumber)
            ->setUuid($uuid);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return RUniversalLineTemplate
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get urgentPriority value
     * @return string|null
     */
    public function getUrgentPriority()
    {
        return $this->urgentPriority;
    }
    /**
     * Set urgentPriority value
     * @param string $urgentPriority
     * @return RUniversalLineTemplate
     */
    public function setUrgentPriority($urgentPriority = null)
    {
        // validation for constraint: pattern
        if (is_scalar($urgentPriority) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $urgentPriority)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($urgentPriority, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($urgentPriority) && !is_string($urgentPriority)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urgentPriority)), __LINE__);
        }
        $this->urgentPriority = $urgentPriority;
        return $this;
    }
    /**
     * Get lineDescription value
     * @return string|null
     */
    public function getLineDescription()
    {
        return $this->lineDescription;
    }
    /**
     * Set lineDescription value
     * @param string $lineDescription
     * @return RUniversalLineTemplate
     */
    public function setLineDescription($lineDescription = null)
    {
        // validation for constraint: string
        if (!is_null($lineDescription) && !is_string($lineDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lineDescription)), __LINE__);
        }
        $this->lineDescription = $lineDescription;
        return $this;
    }
    /**
     * Get routePartition value
     * @return XFkType|null
     */
    public function getRoutePartition()
    {
        return $this->routePartition;
    }
    /**
     * Set routePartition value
     * @param XFkType $routePartition
     * @return RUniversalLineTemplate
     */
    public function setRoutePartition(XFkType $routePartition = null)
    {
        $this->routePartition = $routePartition;
        return $this;
    }
    /**
     * Get voiceMailProfile value
     * @return XFkType|null
     */
    public function getVoiceMailProfile()
    {
        return $this->voiceMailProfile;
    }
    /**
     * Set voiceMailProfile value
     * @param XFkType $voiceMailProfile
     * @return RUniversalLineTemplate
     */
    public function setVoiceMailProfile(XFkType $voiceMailProfile = null)
    {
        $this->voiceMailProfile = $voiceMailProfile;
        return $this;
    }
    /**
     * Get callingSearchSpace value
     * @return XFkType|null
     */
    public function getCallingSearchSpace()
    {
        return $this->callingSearchSpace;
    }
    /**
     * Set callingSearchSpace value
     * @param XFkType $callingSearchSpace
     * @return RUniversalLineTemplate
     */
    public function setCallingSearchSpace(XFkType $callingSearchSpace = null)
    {
        $this->callingSearchSpace = $callingSearchSpace;
        return $this;
    }
    /**
     * Get alertingName value
     * @return string|null
     */
    public function getAlertingName()
    {
        return $this->alertingName;
    }
    /**
     * Set alertingName value
     * @param string $alertingName
     * @return RUniversalLineTemplate
     */
    public function setAlertingName($alertingName = null)
    {
        // validation for constraint: string
        if (!is_null($alertingName) && !is_string($alertingName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alertingName)), __LINE__);
        }
        $this->alertingName = $alertingName;
        return $this;
    }
    /**
     * Get extCallControlProfile value
     * @return XFkType|null
     */
    public function getExtCallControlProfile()
    {
        return $this->extCallControlProfile;
    }
    /**
     * Set extCallControlProfile value
     * @param XFkType $extCallControlProfile
     * @return RUniversalLineTemplate
     */
    public function setExtCallControlProfile(XFkType $extCallControlProfile = null)
    {
        $this->extCallControlProfile = $extCallControlProfile;
        return $this;
    }
    /**
     * Get blfPresenceGroup value
     * @return XFkType|null
     */
    public function getBlfPresenceGroup()
    {
        return $this->blfPresenceGroup;
    }
    /**
     * Set blfPresenceGroup value
     * @param XFkType $blfPresenceGroup
     * @return RUniversalLineTemplate
     */
    public function setBlfPresenceGroup(XFkType $blfPresenceGroup = null)
    {
        $this->blfPresenceGroup = $blfPresenceGroup;
        return $this;
    }
    /**
     * Get callPickupGroup value
     * @return XFkType|null
     */
    public function getCallPickupGroup()
    {
        return $this->callPickupGroup;
    }
    /**
     * Set callPickupGroup value
     * @param XFkType $callPickupGroup
     * @return RUniversalLineTemplate
     */
    public function setCallPickupGroup(XFkType $callPickupGroup = null)
    {
        $this->callPickupGroup = $callPickupGroup;
        return $this;
    }
    /**
     * Get partyEntranceTone value
     * @return string|null
     */
    public function getPartyEntranceTone()
    {
        return $this->partyEntranceTone;
    }
    /**
     * Set partyEntranceTone value
     * @uses XStatus::valueIsValid()
     * @uses XStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $partyEntranceTone
     * @return RUniversalLineTemplate
     */
    public function setPartyEntranceTone($partyEntranceTone = null)
    {
        // validation for constraint: enumeration
        if (!XStatus::valueIsValid($partyEntranceTone)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $partyEntranceTone, implode(', ', XStatus::getValidValues())), __LINE__);
        }
        $this->partyEntranceTone = $partyEntranceTone;
        return $this;
    }
    /**
     * Get autoAnswer value
     * @return string|null
     */
    public function getAutoAnswer()
    {
        return $this->autoAnswer;
    }
    /**
     * Set autoAnswer value
     * @uses XAutoAnswer::valueIsValid()
     * @uses XAutoAnswer::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $autoAnswer
     * @return RUniversalLineTemplate
     */
    public function setAutoAnswer($autoAnswer = null)
    {
        // validation for constraint: enumeration
        if (!XAutoAnswer::valueIsValid($autoAnswer)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $autoAnswer, implode(', ', XAutoAnswer::getValidValues())), __LINE__);
        }
        $this->autoAnswer = $autoAnswer;
        return $this;
    }
    /**
     * Get rejectAnonymousCall value
     * @return string|null
     */
    public function getRejectAnonymousCall()
    {
        return $this->rejectAnonymousCall;
    }
    /**
     * Set rejectAnonymousCall value
     * @param string $rejectAnonymousCall
     * @return RUniversalLineTemplate
     */
    public function setRejectAnonymousCall($rejectAnonymousCall = null)
    {
        // validation for constraint: pattern
        if (is_scalar($rejectAnonymousCall) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $rejectAnonymousCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($rejectAnonymousCall, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($rejectAnonymousCall) && !is_string($rejectAnonymousCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rejectAnonymousCall)), __LINE__);
        }
        $this->rejectAnonymousCall = $rejectAnonymousCall;
        return $this;
    }
    /**
     * Get userHoldMohAudioSource value
     * @return string|null
     */
    public function getUserHoldMohAudioSource()
    {
        return $this->userHoldMohAudioSource;
    }
    /**
     * Set userHoldMohAudioSource value
     * @uses XMOHAudioSourceId::valueIsValid()
     * @uses XMOHAudioSourceId::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $userHoldMohAudioSource
     * @return RUniversalLineTemplate
     */
    public function setUserHoldMohAudioSource($userHoldMohAudioSource = null)
    {
        // validation for constraint: enumeration
        if (!XMOHAudioSourceId::valueIsValid($userHoldMohAudioSource)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $userHoldMohAudioSource, implode(', ', XMOHAudioSourceId::getValidValues())), __LINE__);
        }
        $this->userHoldMohAudioSource = $userHoldMohAudioSource;
        return $this;
    }
    /**
     * Get networkHoldMohAudioSource value
     * @return string|null
     */
    public function getNetworkHoldMohAudioSource()
    {
        return $this->networkHoldMohAudioSource;
    }
    /**
     * Set networkHoldMohAudioSource value
     * @uses XMOHAudioSourceId::valueIsValid()
     * @uses XMOHAudioSourceId::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $networkHoldMohAudioSource
     * @return RUniversalLineTemplate
     */
    public function setNetworkHoldMohAudioSource($networkHoldMohAudioSource = null)
    {
        // validation for constraint: enumeration
        if (!XMOHAudioSourceId::valueIsValid($networkHoldMohAudioSource)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $networkHoldMohAudioSource, implode(', ', XMOHAudioSourceId::getValidValues())), __LINE__);
        }
        $this->networkHoldMohAudioSource = $networkHoldMohAudioSource;
        return $this;
    }
    /**
     * Get aarDestinationMask value
     * @return string|null
     */
    public function getAarDestinationMask()
    {
        return $this->aarDestinationMask;
    }
    /**
     * Set aarDestinationMask value
     * @param string $aarDestinationMask
     * @return RUniversalLineTemplate
     */
    public function setAarDestinationMask($aarDestinationMask = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($aarDestinationMask) && strlen($aarDestinationMask) > 128) || (is_array($aarDestinationMask) && count($aarDestinationMask) > 128)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 128 element(s) or a scalar of 128 character(s) at most, "%d" length given', is_scalar($aarDestinationMask) ? strlen($aarDestinationMask) : count($aarDestinationMask)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($aarDestinationMask) && !is_string($aarDestinationMask)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aarDestinationMask)), __LINE__);
        }
        $this->aarDestinationMask = $aarDestinationMask;
        return $this;
    }
    /**
     * Get aarGroup value
     * @return XFkType|null
     */
    public function getAarGroup()
    {
        return $this->aarGroup;
    }
    /**
     * Set aarGroup value
     * @param XFkType $aarGroup
     * @return RUniversalLineTemplate
     */
    public function setAarGroup(XFkType $aarGroup = null)
    {
        $this->aarGroup = $aarGroup;
        return $this;
    }
    /**
     * Get retainDestInCallFwdHistory value
     * @return string|null
     */
    public function getRetainDestInCallFwdHistory()
    {
        return $this->retainDestInCallFwdHistory;
    }
    /**
     * Set retainDestInCallFwdHistory value
     * @param string $retainDestInCallFwdHistory
     * @return RUniversalLineTemplate
     */
    public function setRetainDestInCallFwdHistory($retainDestInCallFwdHistory = null)
    {
        // validation for constraint: pattern
        if (is_scalar($retainDestInCallFwdHistory) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $retainDestInCallFwdHistory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($retainDestInCallFwdHistory, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($retainDestInCallFwdHistory) && !is_string($retainDestInCallFwdHistory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($retainDestInCallFwdHistory)), __LINE__);
        }
        $this->retainDestInCallFwdHistory = $retainDestInCallFwdHistory;
        return $this;
    }
    /**
     * Get forwardDestAllCalls value
     * @return string|null
     */
    public function getForwardDestAllCalls()
    {
        return $this->forwardDestAllCalls;
    }
    /**
     * Set forwardDestAllCalls value
     * @param string $forwardDestAllCalls
     * @return RUniversalLineTemplate
     */
    public function setForwardDestAllCalls($forwardDestAllCalls = null)
    {
        // validation for constraint: pattern
        if (is_scalar($forwardDestAllCalls) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $forwardDestAllCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($forwardDestAllCalls, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($forwardDestAllCalls) && !is_string($forwardDestAllCalls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($forwardDestAllCalls)), __LINE__);
        }
        $this->forwardDestAllCalls = $forwardDestAllCalls;
        return $this;
    }
    /**
     * Get primaryCssForwardingAllCalls value
     * @return XFkType|null
     */
    public function getPrimaryCssForwardingAllCalls()
    {
        return $this->primaryCssForwardingAllCalls;
    }
    /**
     * Set primaryCssForwardingAllCalls value
     * @param XFkType $primaryCssForwardingAllCalls
     * @return RUniversalLineTemplate
     */
    public function setPrimaryCssForwardingAllCalls(XFkType $primaryCssForwardingAllCalls = null)
    {
        $this->primaryCssForwardingAllCalls = $primaryCssForwardingAllCalls;
        return $this;
    }
    /**
     * Get secondaryCssForwardingAllCalls value
     * @return XFkType|null
     */
    public function getSecondaryCssForwardingAllCalls()
    {
        return $this->secondaryCssForwardingAllCalls;
    }
    /**
     * Set secondaryCssForwardingAllCalls value
     * @param XFkType $secondaryCssForwardingAllCalls
     * @return RUniversalLineTemplate
     */
    public function setSecondaryCssForwardingAllCalls(XFkType $secondaryCssForwardingAllCalls = null)
    {
        $this->secondaryCssForwardingAllCalls = $secondaryCssForwardingAllCalls;
        return $this;
    }
    /**
     * Get CssActivationPolicy value
     * @return string|null
     */
    public function getCssActivationPolicy()
    {
        return $this->CssActivationPolicy;
    }
    /**
     * Set CssActivationPolicy value
     * @uses XCFACSSActivationPolicy::valueIsValid()
     * @uses XCFACSSActivationPolicy::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $cssActivationPolicy
     * @return RUniversalLineTemplate
     */
    public function setCssActivationPolicy($cssActivationPolicy = null)
    {
        // validation for constraint: enumeration
        if (!XCFACSSActivationPolicy::valueIsValid($cssActivationPolicy)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $cssActivationPolicy, implode(', ', XCFACSSActivationPolicy::getValidValues())), __LINE__);
        }
        $this->CssActivationPolicy = $cssActivationPolicy;
        return $this;
    }
    /**
     * Get fwdDestExtCallsWhenNotRetrieved value
     * @return string|null
     */
    public function getFwdDestExtCallsWhenNotRetrieved()
    {
        return $this->fwdDestExtCallsWhenNotRetrieved;
    }
    /**
     * Set fwdDestExtCallsWhenNotRetrieved value
     * @param string $fwdDestExtCallsWhenNotRetrieved
     * @return RUniversalLineTemplate
     */
    public function setFwdDestExtCallsWhenNotRetrieved($fwdDestExtCallsWhenNotRetrieved = null)
    {
        // validation for constraint: string
        if (!is_null($fwdDestExtCallsWhenNotRetrieved) && !is_string($fwdDestExtCallsWhenNotRetrieved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fwdDestExtCallsWhenNotRetrieved)), __LINE__);
        }
        $this->fwdDestExtCallsWhenNotRetrieved = $fwdDestExtCallsWhenNotRetrieved;
        return $this;
    }
    /**
     * Get cssFwdExtCallsWhenNotRetrieved value
     * @return XFkType|null
     */
    public function getCssFwdExtCallsWhenNotRetrieved()
    {
        return $this->cssFwdExtCallsWhenNotRetrieved;
    }
    /**
     * Set cssFwdExtCallsWhenNotRetrieved value
     * @param XFkType $cssFwdExtCallsWhenNotRetrieved
     * @return RUniversalLineTemplate
     */
    public function setCssFwdExtCallsWhenNotRetrieved(XFkType $cssFwdExtCallsWhenNotRetrieved = null)
    {
        $this->cssFwdExtCallsWhenNotRetrieved = $cssFwdExtCallsWhenNotRetrieved;
        return $this;
    }
    /**
     * Get fwdDestInternalCallsWhenNotRetrieved value
     * @return string|null
     */
    public function getFwdDestInternalCallsWhenNotRetrieved()
    {
        return $this->fwdDestInternalCallsWhenNotRetrieved;
    }
    /**
     * Set fwdDestInternalCallsWhenNotRetrieved value
     * @param string $fwdDestInternalCallsWhenNotRetrieved
     * @return RUniversalLineTemplate
     */
    public function setFwdDestInternalCallsWhenNotRetrieved($fwdDestInternalCallsWhenNotRetrieved = null)
    {
        // validation for constraint: pattern
        if (is_scalar($fwdDestInternalCallsWhenNotRetrieved) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $fwdDestInternalCallsWhenNotRetrieved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($fwdDestInternalCallsWhenNotRetrieved, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($fwdDestInternalCallsWhenNotRetrieved) && !is_string($fwdDestInternalCallsWhenNotRetrieved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fwdDestInternalCallsWhenNotRetrieved)), __LINE__);
        }
        $this->fwdDestInternalCallsWhenNotRetrieved = $fwdDestInternalCallsWhenNotRetrieved;
        return $this;
    }
    /**
     * Get cssFwdInternalCallsWhenNotRetrieved value
     * @return XFkType|null
     */
    public function getCssFwdInternalCallsWhenNotRetrieved()
    {
        return $this->cssFwdInternalCallsWhenNotRetrieved;
    }
    /**
     * Set cssFwdInternalCallsWhenNotRetrieved value
     * @param XFkType $cssFwdInternalCallsWhenNotRetrieved
     * @return RUniversalLineTemplate
     */
    public function setCssFwdInternalCallsWhenNotRetrieved(XFkType $cssFwdInternalCallsWhenNotRetrieved = null)
    {
        $this->cssFwdInternalCallsWhenNotRetrieved = $cssFwdInternalCallsWhenNotRetrieved;
        return $this;
    }
    /**
     * Get parkMonitorReversionTime value
     * @return string|null
     */
    public function getParkMonitorReversionTime()
    {
        return $this->parkMonitorReversionTime;
    }
    /**
     * Set parkMonitorReversionTime value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $parkMonitorReversionTime
     * @return RUniversalLineTemplate
     */
    public function setParkMonitorReversionTime($parkMonitorReversionTime = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($parkMonitorReversionTime)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $parkMonitorReversionTime, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->parkMonitorReversionTime = $parkMonitorReversionTime;
        return $this;
    }
    /**
     * Get target value
     * @return string|null
     */
    public function getTarget()
    {
        return $this->target;
    }
    /**
     * Set target value
     * @param string $target
     * @return RUniversalLineTemplate
     */
    public function setTarget($target = null)
    {
        // validation for constraint: string
        if (!is_null($target) && !is_string($target)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($target)), __LINE__);
        }
        $this->target = $target;
        return $this;
    }
    /**
     * Get mlppCss value
     * @return XFkType|null
     */
    public function getMlppCss()
    {
        return $this->mlppCss;
    }
    /**
     * Set mlppCss value
     * @param XFkType $mlppCss
     * @return RUniversalLineTemplate
     */
    public function setMlppCss(XFkType $mlppCss = null)
    {
        $this->mlppCss = $mlppCss;
        return $this;
    }
    /**
     * Get mlppNoAnsRingDuration value
     * @return string|null
     */
    public function getMlppNoAnsRingDuration()
    {
        return $this->mlppNoAnsRingDuration;
    }
    /**
     * Set mlppNoAnsRingDuration value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $mlppNoAnsRingDuration
     * @return RUniversalLineTemplate
     */
    public function setMlppNoAnsRingDuration($mlppNoAnsRingDuration = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($mlppNoAnsRingDuration)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $mlppNoAnsRingDuration, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->mlppNoAnsRingDuration = $mlppNoAnsRingDuration;
        return $this;
    }
    /**
     * Get confidentialAccess value
     * @return ConfidentialAccess|null
     */
    public function getConfidentialAccess()
    {
        return $this->confidentialAccess;
    }
    /**
     * Set confidentialAccess value
     * @param ConfidentialAccess $confidentialAccess
     * @return RUniversalLineTemplate
     */
    public function setConfidentialAccess(ConfidentialAccess $confidentialAccess = null)
    {
        $this->confidentialAccess = $confidentialAccess;
        return $this;
    }
    /**
     * Get holdReversionRingDuration value
     * @return string|null
     */
    public function getHoldReversionRingDuration()
    {
        return $this->holdReversionRingDuration;
    }
    /**
     * Set holdReversionRingDuration value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $holdReversionRingDuration
     * @return RUniversalLineTemplate
     */
    public function setHoldReversionRingDuration($holdReversionRingDuration = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($holdReversionRingDuration)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $holdReversionRingDuration, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->holdReversionRingDuration = $holdReversionRingDuration;
        return $this;
    }
    /**
     * Get holdReversionNotificationInterval value
     * @return string|null
     */
    public function getHoldReversionNotificationInterval()
    {
        return $this->holdReversionNotificationInterval;
    }
    /**
     * Set holdReversionNotificationInterval value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $holdReversionNotificationInterval
     * @return RUniversalLineTemplate
     */
    public function setHoldReversionNotificationInterval($holdReversionNotificationInterval = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($holdReversionNotificationInterval)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $holdReversionNotificationInterval, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->holdReversionNotificationInterval = $holdReversionNotificationInterval;
        return $this;
    }
    /**
     * Get busyIntCallsDestination value
     * @return string|null
     */
    public function getBusyIntCallsDestination()
    {
        return $this->busyIntCallsDestination;
    }
    /**
     * Set busyIntCallsDestination value
     * @param string $busyIntCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setBusyIntCallsDestination($busyIntCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($busyIntCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $busyIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($busyIntCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($busyIntCallsDestination) && !is_string($busyIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($busyIntCallsDestination)), __LINE__);
        }
        $this->busyIntCallsDestination = $busyIntCallsDestination;
        return $this;
    }
    /**
     * Get busyIntCallsCss value
     * @return XFkType|null
     */
    public function getBusyIntCallsCss()
    {
        return $this->busyIntCallsCss;
    }
    /**
     * Set busyIntCallsCss value
     * @param XFkType $busyIntCallsCss
     * @return RUniversalLineTemplate
     */
    public function setBusyIntCallsCss(XFkType $busyIntCallsCss = null)
    {
        $this->busyIntCallsCss = $busyIntCallsCss;
        return $this;
    }
    /**
     * Get busyExtCallsDestination value
     * @return string|null
     */
    public function getBusyExtCallsDestination()
    {
        return $this->busyExtCallsDestination;
    }
    /**
     * Set busyExtCallsDestination value
     * @param string $busyExtCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setBusyExtCallsDestination($busyExtCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($busyExtCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $busyExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($busyExtCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($busyExtCallsDestination) && !is_string($busyExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($busyExtCallsDestination)), __LINE__);
        }
        $this->busyExtCallsDestination = $busyExtCallsDestination;
        return $this;
    }
    /**
     * Get busyExtCallsCss value
     * @return XFkType|null
     */
    public function getBusyExtCallsCss()
    {
        return $this->busyExtCallsCss;
    }
    /**
     * Set busyExtCallsCss value
     * @param XFkType $busyExtCallsCss
     * @return RUniversalLineTemplate
     */
    public function setBusyExtCallsCss(XFkType $busyExtCallsCss = null)
    {
        $this->busyExtCallsCss = $busyExtCallsCss;
        return $this;
    }
    /**
     * Get noAnsIntCallsDestination value
     * @return string|null
     */
    public function getNoAnsIntCallsDestination()
    {
        return $this->noAnsIntCallsDestination;
    }
    /**
     * Set noAnsIntCallsDestination value
     * @param string $noAnsIntCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setNoAnsIntCallsDestination($noAnsIntCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($noAnsIntCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $noAnsIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($noAnsIntCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($noAnsIntCallsDestination) && !is_string($noAnsIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($noAnsIntCallsDestination)), __LINE__);
        }
        $this->noAnsIntCallsDestination = $noAnsIntCallsDestination;
        return $this;
    }
    /**
     * Get noAnsIntCallsCss value
     * @return XFkType|null
     */
    public function getNoAnsIntCallsCss()
    {
        return $this->noAnsIntCallsCss;
    }
    /**
     * Set noAnsIntCallsCss value
     * @param XFkType $noAnsIntCallsCss
     * @return RUniversalLineTemplate
     */
    public function setNoAnsIntCallsCss(XFkType $noAnsIntCallsCss = null)
    {
        $this->noAnsIntCallsCss = $noAnsIntCallsCss;
        return $this;
    }
    /**
     * Get noAnsExtCallsDestination value
     * @return string|null
     */
    public function getNoAnsExtCallsDestination()
    {
        return $this->noAnsExtCallsDestination;
    }
    /**
     * Set noAnsExtCallsDestination value
     * @param string $noAnsExtCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setNoAnsExtCallsDestination($noAnsExtCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($noAnsExtCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $noAnsExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($noAnsExtCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($noAnsExtCallsDestination) && !is_string($noAnsExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($noAnsExtCallsDestination)), __LINE__);
        }
        $this->noAnsExtCallsDestination = $noAnsExtCallsDestination;
        return $this;
    }
    /**
     * Get noAnsExtCallsCss value
     * @return XFkType|null
     */
    public function getNoAnsExtCallsCss()
    {
        return $this->noAnsExtCallsCss;
    }
    /**
     * Set noAnsExtCallsCss value
     * @param XFkType $noAnsExtCallsCss
     * @return RUniversalLineTemplate
     */
    public function setNoAnsExtCallsCss(XFkType $noAnsExtCallsCss = null)
    {
        $this->noAnsExtCallsCss = $noAnsExtCallsCss;
        return $this;
    }
    /**
     * Get noCoverageIntCallsDestination value
     * @return string|null
     */
    public function getNoCoverageIntCallsDestination()
    {
        return $this->noCoverageIntCallsDestination;
    }
    /**
     * Set noCoverageIntCallsDestination value
     * @param string $noCoverageIntCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setNoCoverageIntCallsDestination($noCoverageIntCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($noCoverageIntCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $noCoverageIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($noCoverageIntCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($noCoverageIntCallsDestination) && !is_string($noCoverageIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($noCoverageIntCallsDestination)), __LINE__);
        }
        $this->noCoverageIntCallsDestination = $noCoverageIntCallsDestination;
        return $this;
    }
    /**
     * Get noCoverageIntCallsCss value
     * @return XFkType|null
     */
    public function getNoCoverageIntCallsCss()
    {
        return $this->noCoverageIntCallsCss;
    }
    /**
     * Set noCoverageIntCallsCss value
     * @param XFkType $noCoverageIntCallsCss
     * @return RUniversalLineTemplate
     */
    public function setNoCoverageIntCallsCss(XFkType $noCoverageIntCallsCss = null)
    {
        $this->noCoverageIntCallsCss = $noCoverageIntCallsCss;
        return $this;
    }
    /**
     * Get noCoverageExtCallsDestination value
     * @return string|null
     */
    public function getNoCoverageExtCallsDestination()
    {
        return $this->noCoverageExtCallsDestination;
    }
    /**
     * Set noCoverageExtCallsDestination value
     * @param string $noCoverageExtCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setNoCoverageExtCallsDestination($noCoverageExtCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($noCoverageExtCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $noCoverageExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($noCoverageExtCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($noCoverageExtCallsDestination) && !is_string($noCoverageExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($noCoverageExtCallsDestination)), __LINE__);
        }
        $this->noCoverageExtCallsDestination = $noCoverageExtCallsDestination;
        return $this;
    }
    /**
     * Get noCoverageExtCallsCss value
     * @return XFkType|null
     */
    public function getNoCoverageExtCallsCss()
    {
        return $this->noCoverageExtCallsCss;
    }
    /**
     * Set noCoverageExtCallsCss value
     * @param XFkType $noCoverageExtCallsCss
     * @return RUniversalLineTemplate
     */
    public function setNoCoverageExtCallsCss(XFkType $noCoverageExtCallsCss = null)
    {
        $this->noCoverageExtCallsCss = $noCoverageExtCallsCss;
        return $this;
    }
    /**
     * Get unregisteredIntCallsDestination value
     * @return string|null
     */
    public function getUnregisteredIntCallsDestination()
    {
        return $this->unregisteredIntCallsDestination;
    }
    /**
     * Set unregisteredIntCallsDestination value
     * @param string $unregisteredIntCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setUnregisteredIntCallsDestination($unregisteredIntCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($unregisteredIntCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $unregisteredIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($unregisteredIntCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($unregisteredIntCallsDestination) && !is_string($unregisteredIntCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unregisteredIntCallsDestination)), __LINE__);
        }
        $this->unregisteredIntCallsDestination = $unregisteredIntCallsDestination;
        return $this;
    }
    /**
     * Get unregisteredIntCallsCss value
     * @return XFkType|null
     */
    public function getUnregisteredIntCallsCss()
    {
        return $this->unregisteredIntCallsCss;
    }
    /**
     * Set unregisteredIntCallsCss value
     * @param XFkType $unregisteredIntCallsCss
     * @return RUniversalLineTemplate
     */
    public function setUnregisteredIntCallsCss(XFkType $unregisteredIntCallsCss = null)
    {
        $this->unregisteredIntCallsCss = $unregisteredIntCallsCss;
        return $this;
    }
    /**
     * Get unregisteredExtCallsDestination value
     * @return string|null
     */
    public function getUnregisteredExtCallsDestination()
    {
        return $this->unregisteredExtCallsDestination;
    }
    /**
     * Set unregisteredExtCallsDestination value
     * @param string $unregisteredExtCallsDestination
     * @return RUniversalLineTemplate
     */
    public function setUnregisteredExtCallsDestination($unregisteredExtCallsDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($unregisteredExtCallsDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $unregisteredExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($unregisteredExtCallsDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($unregisteredExtCallsDestination) && !is_string($unregisteredExtCallsDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unregisteredExtCallsDestination)), __LINE__);
        }
        $this->unregisteredExtCallsDestination = $unregisteredExtCallsDestination;
        return $this;
    }
    /**
     * Get unregisteredExtCallsCss value
     * @return XFkType|null
     */
    public function getUnregisteredExtCallsCss()
    {
        return $this->unregisteredExtCallsCss;
    }
    /**
     * Set unregisteredExtCallsCss value
     * @param XFkType $unregisteredExtCallsCss
     * @return RUniversalLineTemplate
     */
    public function setUnregisteredExtCallsCss(XFkType $unregisteredExtCallsCss = null)
    {
        $this->unregisteredExtCallsCss = $unregisteredExtCallsCss;
        return $this;
    }
    /**
     * Get ctiFailureDestination value
     * @return string|null
     */
    public function getCtiFailureDestination()
    {
        return $this->ctiFailureDestination;
    }
    /**
     * Set ctiFailureDestination value
     * @param string $ctiFailureDestination
     * @return RUniversalLineTemplate
     */
    public function setCtiFailureDestination($ctiFailureDestination = null)
    {
        // validation for constraint: pattern
        if (is_scalar($ctiFailureDestination) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $ctiFailureDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($ctiFailureDestination, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($ctiFailureDestination) && !is_string($ctiFailureDestination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ctiFailureDestination)), __LINE__);
        }
        $this->ctiFailureDestination = $ctiFailureDestination;
        return $this;
    }
    /**
     * Get ctiFailureCss value
     * @return XFkType|null
     */
    public function getCtiFailureCss()
    {
        return $this->ctiFailureCss;
    }
    /**
     * Set ctiFailureCss value
     * @param XFkType $ctiFailureCss
     * @return RUniversalLineTemplate
     */
    public function setCtiFailureCss(XFkType $ctiFailureCss = null)
    {
        $this->ctiFailureCss = $ctiFailureCss;
        return $this;
    }
    /**
     * Get callControlAgentProfile value
     * @return string|null
     */
    public function getCallControlAgentProfile()
    {
        return $this->callControlAgentProfile;
    }
    /**
     * Set callControlAgentProfile value
     * @param string $callControlAgentProfile
     * @return RUniversalLineTemplate
     */
    public function setCallControlAgentProfile($callControlAgentProfile = null)
    {
        // validation for constraint: string
        if (!is_null($callControlAgentProfile) && !is_string($callControlAgentProfile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callControlAgentProfile)), __LINE__);
        }
        $this->callControlAgentProfile = $callControlAgentProfile;
        return $this;
    }
    /**
     * Get enterpriseAltNum value
     * @return EnterpriseAltNum|null
     */
    public function getEnterpriseAltNum()
    {
        return $this->enterpriseAltNum;
    }
    /**
     * Set enterpriseAltNum value
     * @param EnterpriseAltNum $enterpriseAltNum
     * @return RUniversalLineTemplate
     */
    public function setEnterpriseAltNum(EnterpriseAltNum $enterpriseAltNum = null)
    {
        $this->enterpriseAltNum = $enterpriseAltNum;
        return $this;
    }
    /**
     * Get e164AltNum value
     * @return E164AltNum|null
     */
    public function getE164AltNum()
    {
        return $this->e164AltNum;
    }
    /**
     * Set e164AltNum value
     * @param E164AltNum $e164AltNum
     * @return RUniversalLineTemplate
     */
    public function setE164AltNum(E164AltNum $e164AltNum = null)
    {
        $this->e164AltNum = $e164AltNum;
        return $this;
    }
    /**
     * Get advertisedFailoverNumber value
     * @return string|null
     */
    public function getAdvertisedFailoverNumber()
    {
        return $this->advertisedFailoverNumber;
    }
    /**
     * Set advertisedFailoverNumber value
     * @param string $advertisedFailoverNumber
     * @return RUniversalLineTemplate
     */
    public function setAdvertisedFailoverNumber($advertisedFailoverNumber = null)
    {
        // validation for constraint: string
        if (!is_null($advertisedFailoverNumber) && !is_string($advertisedFailoverNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($advertisedFailoverNumber)), __LINE__);
        }
        $this->advertisedFailoverNumber = $advertisedFailoverNumber;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return RUniversalLineTemplate
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: pattern
        if (is_scalar($uuid) && !preg_match('/\{........-....-....-....-............\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\{........-....-....-....-............\}", "%s" given', var_export($uuid, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uuid)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return RUniversalLineTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
